metadata:
  name: sdk-debos-image-building
  format: "Apertis Test Definition 1.0"
  image-types:
    basesdk: [ amd64 ]
    sdk:     [ amd64 ]
  image-deployment:
    - APT
  group: "sdk"
  type: functional
  exec-type: automated
  priority: critical
  maintainer: "Apertis Project"
  description: >
    Ensure that the sample image recipes can be built on the SDK and
    that the commands in the documentation work.

  pre-conditions:
    - "Plenty of free storage space must be available as the test will consume up to 15GB"
    - "Network connectivity on the DUT as these tests fetch packages and data over
       the network."

  expected:
    - The automated test should succeed

  notes:
    - "Lots of debos messages will be logged on the standard output. Upon test fail,
       the script will abort with:"
    - |
        >Job for generated-test-case-test-sample-documentation.service failed because the control process exited with error code.
        >See "systemctl --user status generated-test-case-test-sample-documentation.service" and "journalctl --user -xe" for details.
        >Command exited with non-zero status 1

install:
  git-repos:
    - url: https://gitlab.apertis.org/pkg/apertis-tests.git
      branch: 'apertis/v2023dev1'
    - url: https://gitlab.apertis.org/infrastructure/apertis-image-recipes.git
      branch: 'apertis/v2023dev1'

run:
  steps:
    - "# add `run-test-in-systemd` to the PATH"
    - "PATH=$(pwd)/apertis-tests/common/:$PATH"
    - "# build under /home which has enough storage space"
    - "sudo -u user cp -a ./apertis-image-recipes ~user/ && cd ~user/apertis-image-recipes"
    - "# VirtualBox doesn't support nested KVM virtualization, so check that we don't have kvm as well"
    - "# this should trigger the chroot-based Debos backend instead of the fakemachine one"
    - "run-test-in-systemd --user=user --timeout=5min --name ensure-no-kvm test ! -e /dev/kvm"
    - "run-test-in-systemd --user=user --timeout=180min --name test-sample-documentation test/test-sample-documentation"
